SystemOrganization addCategory: #PlateManager!

GRObject subclass: #PMAllUsers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

!PMAllUsers commentStamp: 'mbc 4/30/2018 13:00' prior: 0!
I am a collection of all users.
I use the Dictionary collection, with the userName being the key
usernames are one word all lower case letters only.!

GRObject subclass: #PMAssayRun
	instanceVariableNames: 'uniqueID assayType assayRunName assayRunDescription timestamp plateSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

PMAssayRun class
	instanceVariableNames: 'assayTypes count'!

!PMAssayRun commentStamp: 'mbc 4/30/2018 11:33' prior: 0!
An assay run is performed on a plate set.
I have a type.
My results may determine hits.
!

PMAssayRun class
	instanceVariableNames: 'assayTypes count'!

!PMAssayRun class methodsFor: 'accessing' stamp: 'mbc 4/30/2018 11:47'!
count
	"comment stating purpose of message"

	^ count! !

!PMAssayRun class methodsFor: 'as yet unclassified' stamp: 'mbc 4/30/2018 11:46'!
createInstance: aPlateSet assayType: anAssayType
	"comment stating purpose of message"

	count := count + 1.
	^ self basicNew
		initializeWithPlateSet: aPlateSet assayType: anAssayType;
		yourself! !

!PMAssayRun class methodsFor: 'initialization' stamp: 'mbc 4/30/2018 11:42'!
initialize
	"comment stating purpose of message"

	count := 0! !

PMAssayRun initialize!

!PMAssayRun class methodsFor: 'instance creation' stamp: 'mbc 4/30/2018 11:42'!
new
	"comment stating purpose of message"

	^ super new! !

!PMAssayRun methodsFor: 'initialization' stamp: 'mbc 4/30/2018 11:49'!
initializeWithPlateSet: aPlateSet assayType: anAssayType
		
	assayRunName := 'AR' , PMAssayRun count greaseString.
	timestamp := DateAndTime now.
	uniqueID := UUID new.
	plateSet := aPlateSet.
	self initialize! !

GRObject subclass: #PMHitList
	instanceVariableNames: 'hitListID hitListDescription timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

!PMHitList commentStamp: 'mbc 4/30/2018 11:33' prior: 0!
A hit list is a collection of samples that meet a criteria.
Assay results may determine a hit list.!

GRObject subclass: #PMPlate
	instanceVariableNames: 'wellsArray numberOfWells plateType sequenceNumber plateFormat'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

PMPlate class
	instanceVariableNames: 'count'!

!PMPlate commentStamp: 'MortimerCladwell 3/24/2018 08:31' prior: 0!
A Plate class is 96 or 384 well plate.
!

PMPlate class
	instanceVariableNames: 'count'!

!PMPlate class methodsFor: 'as yet unclassified' stamp: 'mbc 4/9/2018 14:24'!
get1536WellName: index
	"comment stating purpose of message"

	wellNames := #('A01' 'B01' 'C01' 'D01' 'E01' 'F01' 'G01' 'H01' 'I01' 'J01' 'K01' 'L01' 'M01' 'N01' 'O01' 'P01' 'Q01' 'R01' 'S01' 'T01' 'U01' 'V01' 'W01' 'X01' 'Y01' 'Z01' 'AA01' 'AB01' 'AC01' 'AD01' 'AE01' 'AF01' 'A02' 'B02' 'C02' 'D02' 'E02' 'F02' 'G02' 'H02' 'I02' 'J02' 'K02' 'L02' 'M02' 'N02' 'O02' 'P02' 'Q02' 'R02' 'S02' 'T02' 'U02' 'V02' 'W02' 'X02' 'Y02' 'Z02' 'AA02' 'AB02' 'AC02' 'AD02' 'AE02' 'AF02' 'A03' 'B03' 'C03' 'D03' 'E03' 'F03' 'G03' 'H03' 'I03' 'J03' 'K03' 'L03' 'M03' 'N03' 'O03' 'P03' 'Q03' 'R03' 'S03' 'T03' 'U03' 'V03' 'W03' 'X03' 'Y03' 'Z03' 'AA03' 'AB03' 'AC03' 'AD03' 'AE03' 'AF03' 'A04' 'B04' 'C04' 'D04' 'E04' 'F04' 'G04' 'H04' 'I04' 'J04' 'K04' 'L04' 'M04' 'N04' 'O04' 'P04' 'Q04' 'R04' 'S04' 'T04' 'U04' 'V04' 'W04' 'X04' 'Y04' 'Z04' 'AA04' 'AB04' 'AC04' 'AD04' 'AE04' 'AF04' 'A05' 'B05' 'C05' 'D05' 'E05' 'F05' 'G05' 'H05' 'I05' 'J05' 'K05' 'L05' 'M05' 'N05' 'O05' 'P05' 'Q05' 'R05' 'S05' 'T05' 'U05' 'V05' 'W05' 'X05' 'Y05' 'Z05' 'AA05' 'AB05' 'AC05' 'AD05' 'AE05' 'AF05' 'A06' 'B06' 'C06' 'D06' 'E06' 'F06' 'G06' 'H06' 'I06' 'J06' 'K06' 'L06' 'M06' 'N06' 'O06' 'P06' 'Q06' 'R06' 'S06' 'T06' 'U06' 'V06' 'W06' 'X06' 'Y06' 'Z06' 'AA06' 'AB06' 'AC06' 'AD06' 'AE06' 'AF06' 'A07' 'B07' 'C07' 'D07' 'E07' 'F07' 'G07' 'H07' 'I07' 'J07' 'K07' 'L07' 'M07' 'N07' 'O07' 'P07' 'Q07' 'R07' 'S07' 'T07' 'U07' 'V07' 'W07' 'X07' 'Y07' 'Z07' 'AA07' 'AB07' 'AC07' 'AD07' 'AE07' 'AF07' 'A08' 'B08' 'C08' 'D08' 'E08' 'F08' 'G08' 'H08' 'I08' 'J08' 'K08' 'L08' 'M08' 'N08' 'O08' 'P08' 'Q08' 'R08' 'S08' 'T08' 'U08' 'V08' 'W08' 'X08' 'Y08' 'Z08' 'AA08' 'AB08' 'AC08' 'AD08' 'AE08' 'AF08' 'A09' 'B09' 'C09' 'D09' 'E09' 'F09' 'G09' 'H09' 'I09' 'J09' 'K09' 'L09' 'M09' 'N09' 'O09' 'P09' 'Q09' 'R09' 'S09' 'T09' 'U09' 'V09' 'W09' 'X09' 'Y09' 'Z09' 'AA09' 'AB09' 'AC09' 'AD09' 'AE09' 'AF09' 'A10' 'B10' 'C10' 'D10' 'E10' 'F10' 'G10' 'H10' 'I10' 'J10' 'K10' 'L10' 'M10' 'N10' 'O10' 'P10' 'Q10' 'R10' 'S10' 'T10' 'U10' 'V10' 'W10' 'X10' 'Y10' 'Z10' 'AA10' 'AB10' 'AC10' 'AD10' 'AE10' 'AF10' 'A11' 'B11' 'C11' 'D11' 'E11' 'F11' 'G11' 'H11' 'I11' 'J11' 'K11' 'L11' 'M11' 'N11' 'O11' 'P11' 'Q11' 'R11' 'S11' 'T11' 'U11' 'V11' 'W11' 'X11' 'Y11' 'Z11' 'AA11' 'AB11' 'AC11' 'AD11' 'AE11' 'AF11' 'A12' 'B12' 'C12' 'D12' 'E12' 'F12' 'G12' 'H12' 'I12' 'J12' 'K12' 'L12' 'M12' 'N12' 'O12' 'P12' 'Q12' 'R12' 'S12' 'T12' 'U12' 'V12' 'W12' 'X12' 'Y12' 'Z12' 'AA12' 'AB12' 'AC12' 'AD12' 'AE12' 'AF12' 'A13' 'B13' 'C13' 'D13' 'E13' 'F13' 'G13' 'H13' 'I13' 'J13' 'K13' 'L13' 'M13' 'N13' 'O13' 'P13' 'Q13' 'R13' 'S13' 'T13' 'U13' 'V13' 'W13' 'X13' 'Y13' 'Z13' 'AA13' 'AB13' 'AC13' 'AD13' 'AE13' 'AF13' 'A14' 'B14' 'C14' 'D14' 'E14' 'F14' 'G14' 'H14' 'I14' 'J14' 'K14' 'L14' 'M14' 'N14' 'O14' 'P14' 'Q14' 'R14' 'S14' 'T14' 'U14' 'V14' 'W14' 'X14' 'Y14' 'Z14' 'AA14' 'AB14' 'AC14' 'AD14' 'AE14' 'AF14' 'A15' 'B15' 'C15' 'D15' 'E15' 'F15' 'G15' 'H15' 'I15' 'J15' 'K15' 'L15' 'M15' 'N15' 'O15' 'P15' 'Q15' 'R15' 'S15' 'T15' 'U15' 'V15' 'W15' 'X15' 'Y15' 'Z15' 'AA15' 'AB15' 'AC15' 'AD15' 'AE15' 'AF15' 'A16' 'B16' 'C16' 'D16' 'E16' 'F16' 'G16' 'H16' 'I16' 'J16' 'K16' 'L16' 'M16' 'N16' 'O16' 'P16' 'Q16' 'R16' 'S16' 'T16' 'U16' 'V16' 'W16' 'X16' 'Y16' 'Z16' 'AA16' 'AB16' 'AC16' 'AD16' 'AE16' 'AF16' 'A17' 'B17' 'C17' 'D17' 'E17' 'F17' 'G17' 'H17' 'I17' 'J17' 'K17' 'L17' 'M17' 'N17' 'O17' 'P17' 'Q17' 'R17' 'S17' 'T17' 'U17' 'V17' 'W17' 'X17' 'Y17' 'Z17' 'AA17' 'AB17' 'AC17' 'AD17' 'AE17' 'AF17' 'A18' 'B18' 'C18' 'D18' 'E18' 'F18' 'G18' 'H18' 'I18' 'J18' 'K18' 'L18' 'M18' 'N18' 'O18' 'P18' 'Q18' 'R18' 'S18' 'T18' 'U18' 'V18' 'W18' 'X18' 'Y18' 'Z18' 'AA18' 'AB18' 'AC18' 'AD18' 'AE18' 'AF18' 'A19' 'B19' 'C19' 'D19' 'E19' 'F19' 'G19' 'H19' 'I19' 'J19' 'K19' 'L19' 'M19' 'N19' 'O19' 'P19' 'Q19' 'R19' 'S19' 'T19' 'U19' 'V19' 'W19' 'X19' 'Y19' 'Z19' 'AA19' 'AB19' 'AC19' 'AD19' 'AE19' 'AF19' 'A20' 'B20' 'C20' 'D20' 'E20' 'F20' 'G20' 'H20' 'I20' 'J20' 'K20' 'L20' 'M20' 'N20' 'O20' 'P20' 'Q20' 'R20' 'S20' 'T20' 'U20' 'V20' 'W20' 'X20' 'Y20' 'Z20' 'AA20' 'AB20' 'AC20' 'AD20' 'AE20' 'AF20' 'A21' 'B21' 'C21' 'D21' 'E21' 'F21' 'G21' 'H21' 'I21' 'J21' 'K21' 'L21' 'M21' 'N21' 'O21' 'P21' 'Q21' 'R21' 'S21' 'T21' 'U21' 'V21' 'W21' 'X21' 'Y21' 'Z21' 'AA21' 'AB21' 'AC21' 'AD21' 'AE21' 'AF21' 'A22' 'B22' 'C22' 'D22' 'E22' 'F22' 'G22' 'H22' 'I22' 'J22' 'K22' 'L22' 'M22' 'N22' 'O22' 'P22' 'Q22' 'R22' 'S22' 'T22' 'U22' 'V22' 'W22' 'X22' 'Y22' 'Z22' 'AA22' 'AB22' 'AC22' 'AD22' 'AE22' 'AF22' 'A23' 'B23' 'C23' 'D23' 'E23' 'F23' 'G23' 'H23' 'I23' 'J23' 'K23' 'L23' 'M23' 'N23' 'O23' 'P23' 'Q23' 'R23' 'S23' 'T23' 'U23' 'V23' 'W23' 'X23' 'Y23' 'Z23' 'AA23' 'AB23' 'AC23' 'AD23' 'AE23' 'AF23' 'A24' 'B24' 'C24' 'D24' 'E24' 'F24' 'G24' 'H24' 'I24' 'J24' 'K24' 'L24' 'M24' 'N24' 'O24' 'P24' 'Q24' 'R24' 'S24' 'T24' 'U24' 'V24' 'W24' 'X24' 'Y24' 'Z24' 'AA24' 'AB24' 'AC24' 'AD24' 'AE24' 'AF24' 'A25' 'B25' 'C25' 'D25' 'E25' 'F25' 'G25' 'H25' 'I25' 'J25' 'K25' 'L25' 'M25' 'N25' 'O25' 'P25' 'Q25' 'R25' 'S25' 'T25' 'U25' 'V25' 'W25' 'X25' 'Y25' 'Z25' 'AA25' 'AB25' 'AC25' 'AD25' 'AE25' 'AF25' 'A26' 'B26' 'C26' 'D26' 'E26' 'F26' 'G26' 'H26' 'I26' 'J26' 'K26' 'L26' 'M26' 'N26' 'O26' 'P26' 'Q26' 'R26' 'S26' 'T26' 'U26' 'V26' 'W26' 'X26' 'Y26' 'Z26' 'AA26' 'AB26' 'AC26' 'AD26' 'AE26' 'AF26' 'A27' 'B27' 'C27' 'D27' 'E27' 'F27' 'G27' 'H27' 'I27' 'J27' 'K27' 'L27' 'M27' 'N27' 'O27' 'P27' 'Q27' 'R27' 'S27' 'T27' 'U27' 'V27' 'W27' 'X27' 'Y27' 'Z27' 'AA27' 'AB27' 'AC27' 'AD27' 'AE27' 'AF27' 'A28' 'B28' 'C28' 'D28' 'E28' 'F28' 'G28' 'H28' 'I28' 'J28' 'K28' 'L28' 'M28' 'N28' 'O28' 'P28' 'Q28' 'R28' 'S28' 'T28' 'U28' 'V28' 'W28' 'X28' 'Y28' 'Z28' 'AA28' 'AB28' 'AC28' 'AD28' 'AE28' 'AF28' 'A29' 'B29' 'C29' 'D29' 'E29' 'F29' 'G29' 'H29' 'I29' 'J29' 'K29' 'L29' 'M29' 'N29' 'O29' 'P29' 'Q29' 'R29' 'S29' 'T29' 'U29' 'V29' 'W29' 'X29' 'Y29' 'Z29' 'AA29' 'AB29' 'AC29' 'AD29' 'AE29' 'AF29' 'A30' 'B30' 'C30' 'D30' 'E30' 'F30' 'G30' 'H30' 'I30' 'J30' 'K30' 'L30' 'M30' 'N30' 'O30' 'P30' 'Q30' 'R30' 'S30' 'T30' 'U30' 'V30' 'W30' 'X30' 'Y30' 'Z30' 'AA30' 'AB30' 'AC30' 'AD30' 'AE30' 'AF30' 'A31' 'B31' 'C31' 'D31' 'E31' 'F31' 'G31' 'H31' 'I31' 'J31' 'K31' 'L31' 'M31' 'N31' 'O31' 'P31' 'Q31' 'R31' 'S31' 'T31' 'U31' 'V31' 'W31' 'X31' 'Y31' 'Z31' 'AA31' 'AB31' 'AC31' 'AD31' 'AE31' 'AF31' 'A32' 'B32' 'C32' 'D32' 'E32' 'F32' 'G32' 'H32' 'I32' 'J32' 'K32' 'L32' 'M32' 'N32' 'O32' 'P32' 'Q32' 'R32' 'S32' 'T32' 'U32' 'V32' 'W32' 'X32' 'Y32' 'Z32' 'AA32' 'AB32' 'AC32' 'AD32' 'AE32' 'AF32' 'A33' 'B33' 'C33' 'D33' 'E33' 'F33' 'G33' 'H33' 'I33' 'J33' 'K33' 'L33' 'M33' 'N33' 'O33' 'P33' 'Q33' 'R33' 'S33' 'T33' 'U33' 'V33' 'W33' 'X33' 'Y33' 'Z33' 'AA33' 'AB33' 'AC33' 'AD33' 'AE33' 'AF33' 'A34' 'B34' 'C34' 'D34' 'E34' 'F34' 'G34' 'H34' 'I34' 'J34' 'K34' 'L34' 'M34' 'N34' 'O34' 'P34' 'Q34' 'R34' 'S34' 'T34' 'U34' 'V34' 'W34' 'X34' 'Y34' 'Z34' 'AA34' 'AB34' 'AC34' 'AD34' 'AE34' 'AF34' 'A35' 'B35' 'C35' 'D35' 'E35' 'F35' 'G35' 'H35' 'I35' 'J35' 'K35' 'L35' 'M35' 'N35' 'O35' 'P35' 'Q35' 'R35' 'S35' 'T35' 'U35' 'V35' 'W35' 'X35' 'Y35' 'Z35' 'AA35' 'AB35' 'AC35' 'AD35' 'AE35' 'AF35' 'A36' 'B36' 'C36' 'D36' 'E36' 'F36' 'G36' 'H36' 'I36' 'J36' 'K36' 'L36' 'M36' 'N36' 'O36' 'P36' 'Q36' 'R36' 'S36' 'T36' 'U36' 'V36' 'W36' 'X36' 'Y36' 'Z36' 'AA36' 'AB36' 'AC36' 'AD36' 'AE36' 'AF36' 'A37' 'B37' 'C37' 'D37' 'E37' 'F37' 'G37' 'H37' 'I37' 'J37' 'K37' 'L37' 'M37' 'N37' 'O37' 'P37' 'Q37' 'R37' 'S37' 'T37' 'U37' 'V37' 'W37' 'X37' 'Y37' 'Z37' 'AA37' 'AB37' 'AC37' 'AD37' 'AE37' 'AF37' 'A38' 'B38' 'C38' 'D38' 'E38' 'F38' 'G38' 'H38' 'I38' 'J38' 'K38' 'L38' 'M38' 'N38' 'O38' 'P38' 'Q38' 'R38' 'S38' 'T38' 'U38' 'V38' 'W38' 'X38' 'Y38' 'Z38' 'AA38' 'AB38' 'AC38' 'AD38' 'AE38' 'AF38' 'A39' 'B39' 'C39' 'D39' 'E39' 'F39' 'G39' 'H39' 'I39' 'J39' 'K39' 'L39' 'M39' 'N39' 'O39' 'P39' 'Q39' 'R39' 'S39' 'T39' 'U39' 'V39' 'W39' 'X39' 'Y39' 'Z39' 'AA39' 'AB39' 'AC39' 'AD39' 'AE39' 'AF39' 'A40' 'B40' 'C40' 'D40' 'E40' 'F40' 'G40' 'H40' 'I40' 'J40' 'K40' 'L40' 'M40' 'N40' 'O40' 'P40' 'Q40' 'R40' 'S40' 'T40' 'U40' 'V40' 'W40' 'X40' 'Y40' 'Z40' 'AA40' 'AB40' 'AC40' 'AD40' 'AE40' 'AF40' 'A41' 'B41' 'C41' 'D41' 'E41' 'F41' 'G41' 'H41' 'I41' 'J41' 'K41' 'L41' 'M41' 'N41' 'O41' 'P41' 'Q41' 'R41' 'S41' 'T41' 'U41' 'V41' 'W41' 'X41' 'Y41' 'Z41' 'AA41' 'AB41' 'AC41' 'AD41' 'AE41' 'AF41' 'A42' 'B42' 'C42' 'D42' 'E42' 'F42' 'G42' 'H42' 'I42' 'J42' 'K42' 'L42' 'M42' 'N42' 'O42' 'P42' 'Q42' 'R42' 'S42' 'T42' 'U42' 'V42' 'W42' 'X42' 'Y42' 'Z42' 'AA42' 'AB42' 'AC42' 'AD42' 'AE42' 'AF42' 'A43' 'B43' 'C43' 'D43' 'E43' 'F43' 'G43' 'H43' 'I43' 'J43' 'K43' 'L43' 'M43' 'N43' 'O43' 'P43' 'Q43' 'R43' 'S43' 'T43' 'U43' 'V43' 'W43' 'X43' 'Y43' 'Z43' 'AA43' 'AB43' 'AC43' 'AD43' 'AE43' 'AF43' 'A44' 'B44' 'C44' 'D44' 'E44' 'F44' 'G44' 'H44' 'I44' 'J44' 'K44' 'L44' 'M44' 'N44' 'O44' 'P44' 'Q44' 'R44' 'S44' 'T44' 'U44' 'V44' 'W44' 'X44' 'Y44' 'Z44' 'AA44' 'AB44' 'AC44' 'AD44' 'AE44' 'AF44' 'A45' 'B45' 'C45' 'D45' 'E45' 'F45' 'G45' 'H45' 'I45' 'J45' 'K45' 'L45' 'M45' 'N45' 'O45' 'P45' 'Q45' 'R45' 'S45' 'T45' 'U45' 'V45' 'W45' 'X45' 'Y45' 'Z45' 'AA45' 'AB45' 'AC45' 'AD45' 'AE45' 'AF45' 'A46' 'B46' 'C46' 'D46' 'E46' 'F46' 'G46' 'H46' 'I46' 'J46' 'K46' 'L46' 'M46' 'N46' 'O46' 'P46' 'Q46' 'R46' 'S46' 'T46' 'U46' 'V46' 'W46' 'X46' 'Y46' 'Z46' 'AA46' 'AB46' 'AC46' 'AD46' 'AE46' 'AF46' 'A47' 'B47' 'C47' 'D47' 'E47' 'F47' 'G47' 'H47' 'I47' 'J47' 'K47' 'L47' 'M47' 'N47' 'O47' 'P47' 'Q47' 'R47' 'S47' 'T47' 'U47' 'V47' 'W47' 'X47' 'Y47' 'Z47' 'AA47' 'AB47' 'AC47' 'AD47' 'AE47' 'AF47' 'A48' 'B48' 'C48' 'D48' 'E48' 'F48' 'G48' 'H48' 'I48' 'J48' 'K48' 'L48' 'M48' 'N48' 'O48' 'P48' 'Q48' 'R48' 'S48' 'T48' 'U48' 'V48' 'W48' 'X48' 'Y48' 'Z48' 'AA48' 'AB48' 'AC48' 'AD48' 'AE48' 'AF48').
	^ wellNames at: index! !

!PMPlate class methodsFor: 'as yet unclassified' stamp: 'mbc 4/9/2018 13:52'!
get384WellName: index
	"comment stating purpose of message"

	wellNames := #('A01' 'B01' 'C01' 'D01' 'E01' 'F01' 'G01' 'H01' 'I01' 'J01' 'K01' 'L01' 'M01' 'N01' 'O01' 'P01' 'A02' 'B02' 'C02' 'D02' 'E02' 'F02' 'G02' 'H02' 'I02' 'J02' 'K02' 'L02' 'M02' 'N02' 'O02' 'P02' 'A03' 'B03' 'C03' 'D03' 'E03' 'F03' 'G03' 'H03' 'I03' 'J03' 'K03' 'L03' 'M03' 'N03' 'O03' 'P03' 'A04' 'B04' 'C04' 'D04' 'E04' 'F04' 'G04' 'H04' 'I04' 'J04' 'K04' 'L04' 'M04' 'N04' 'O04' 'P04' 'A05' 'B05' 'C05' 'D05' 'E05' 'F05' 'G05' 'H05' 'I05' 'J05' 'K05' 'L05' 'M05' 'N05' 'O05' 'P05' 'A06' 'B06' 'C06' 'D06' 'E06' 'F06' 'G06' 'H06' 'I06' 'J06' 'K06' 'L06' 'M06' 'N06' 'O06' 'P06' 'A07' 'B07' 'C07' 'D07' 'E07' 'F07' 'G07' 'H07' 'I07' 'J07' 'K07' 'L07' 'M07' 'N07' 'O07' 'P07' 'A08' 'B08' 'C08' 'D08' 'E08' 'F08' 'G08' 'H08' 'I08' 'J08' 'K08' 'L08' 'M08' 'N08' 'O08' 'P08' 'A09' 'B09' 'C09' 'D09' 'E09' 'F09' 'G09' 'H09' 'I09' 'J09' 'K09' 'L09' 'M09' 'N09' 'O09' 'P09' 'A10' 'B10' 'C10' 'D10' 'E10' 'F10' 'G10' 'H10' 'I10' 'J10' 'K10' 'L10' 'M10' 'N10' 'O10' 'P10' 'A11' 'B11' 'C11' 'D11' 'E11' 'F11' 'G11' 'H11' 'I11' 'J11' 'K11' 'L11' 'M11' 'N11' 'O11' 'P11' 'A12' 'B12' 'C12' 'D12' 'E12' 'F12' 'G12' 'H12' 'I12' 'J12' 'K12' 'L12' 'M12' 'N12' 'O12' 'P12' 'A13' 'B13' 'C13' 'D13' 'E13' 'F13' 'G13' 'H13' 'I13' 'J13' 'K13' 'L13' 'M13' 'N13' 'O13' 'P13' 'A14' 'B14' 'C14' 'D14' 'E14' 'F14' 'G14' 'H14' 'I14' 'J14' 'K14' 'L14' 'M14' 'N14' 'O14' 'P14' 'A15' 'B15' 'C15' 'D15' 'E15' 'F15' 'G15' 'H15' 'I15' 'J15' 'K15' 'L15' 'M15' 'N15' 'O15' 'P15' 'A16' 'B16' 'C16' 'D16' 'E16' 'F16' 'G16' 'H16' 'I16' 'J16' 'K16' 'L16' 'M16' 'N16' 'O16' 'P16' 'A17' 'B17' 'C17' 'D17' 'E17' 'F17' 'G17' 'H17' 'I17' 'J17' 'K17' 'L17' 'M17' 'N17' 'O17' 'P17' 'A18' 'B18' 'C18' 'D18' 'E18' 'F18' 'G18' 'H18' 'I18' 'J18' 'K18' 'L18' 'M18' 'N18' 'O18' 'P18' 'A19' 'B19' 'C19' 'D19' 'E19' 'F19' 'G19' 'H19' 'I19' 'J19' 'K19' 'L19' 'M19' 'N19' 'O19' 'P19' 'A20' 'B20' 'C20' 'D20' 'E20' 'F20' 'G20' 'H20' 'I20' 'J20' 'K20' 'L20' 'M20' 'N20' 'O20' 'P20' 'A21' 'B21' 'C21' 'D21' 'E21' 'F21' 'G21' 'H21' 'I21' 'J21' 'K21' 'L21' 'M21' 'N21' 'O21' 'P21' 'A22' 'B22' 'C22' 'D22' 'E22' 'F22' 'G22' 'H22' 'I22' 'J22' 'K22' 'L22' 'M22' 'N22' 'O22' 'P22' 'A23' 'B23' 'C23' 'D23' 'E23' 'F23' 'G23' 'H23' 'I23' 'J23' 'K23' 'L23' 'M23' 'N23' 'O23' 'P23' 'A24' 'B24' 'C24' 'D24' 'E24' 'F24' 'G24' 'H24' 'I24' 'J24' 'K24' 'L24' 'M24' 'N24' 'O24' 'P24').
	^ wellNames at: index! !

!PMPlate class methodsFor: 'as yet unclassified' stamp: 'mbc 4/9/2018 13:37'!
get96WellName: index
	"comment stating purpose of message"

	wellNames := #('A01' 'B01' 'C01' 'D01' 'E01' 'F01' 'G01' 'H01' 'A02' 'B02' 'C02' 'D02' 'E02' 'F02' 'G02' 'H02' 'A03' 'B03' 'C03' 'D03' 'E03' 'F03' 'G03' 'H03' 'A04' 'B04' 'C04' 'D04' 'E04' 'F04' 'G04' 'H04' 'A05' 'B05' 'C05' 'D05' 'E05' 'F05' 'G05' 'H05' 'A06' 'B06' 'C06' 'D06' 'E06' 'F06' 'G06' 'H06' 'A07' 'B07' 'C07' 'D07' 'E07' 'F07' 'G07' 'H07' 'A08' 'B08' 'C08' 'D08' 'E08' 'F08' 'G08' 'H08' 'A09' 'B09' 'C09' 'D09' 'E09' 'F09' 'G09' 'H09' 'A10' 'B10' 'C10' 'D10' 'E10' 'F10' 'G10' 'H10' 'A11' 'B11' 'C11' 'D11' 'E11' 'F11' 'G11' 'H11' 'A12' 'B12' 'C12' 'D12' 'E12' 'F12' 'G12' 'H12').
	^ wellNames at: index! !

!PMPlate class methodsFor: 'as yet unclassified' stamp: 'mbc 4/9/2018 12:07'!
getWellName: index
	"comment stating purpose of message"

	wellNames := #('A01' 'B01' 'C01' 'D01' 'E01' 'F01' 'G01' 'H01' 'A02' 'B02' 'C02' 'D02' 'E02' 'F02' 'G02' 'H02' 'A03' 'B03' 'C03' 'D03' 'E03' 'F03' 'G03' 'H03' 'A04' 'B04' 'C04' 'D04' 'E04' 'F04' 'G04' 'H04' 'A05' 'B05' 'C05' 'D05' 'E05' 'F05' 'G05' 'H05' 'A06' 'B06' 'C06' 'D06' 'E06' 'F06' 'G06' 'H06' 'A07' 'B07' 'C07' 'D07' 'E07' 'F07' 'G07' 'H07' 'A08' 'B08' 'C08' 'D08' 'E08' 'F08' 'G08' 'H08' 'A09' 'B09' 'C09' 'D09' 'E09' 'F09' 'G09' 'H09' 'A10' 'B10' 'C10' 'D10' 'E10' 'F10' 'G10' 'H10' 'A11' 'B11' 'C11' 'D11' 'E11' 'F11' 'G11' 'H11' 'A12' 'B12' 'C12' 'D12' 'E12' 'F12' 'G12' 'H12').
	^wellNames at: index! !

!PMPlate class methodsFor: 'initialization' stamp: 'MortimerCladwell 4/29/2018 15:05'!
initializePM: aNumberOfWells
	"Uses the instance side accessor initializeNumberOfWells to set an instance side variable"

	| |
	^ self basicNew
	       initializeNumberOfWells: aNumberOfWells;
	yourself ! !

!PMPlate class methodsFor: 'initialization' stamp: 'MortimerCladwell 4/29/2018 15:05'!
new
	"comment stating purpose of message"

	|  |
	^ self initializePM: 96! !

!PMPlate methodsFor: 'initialization' stamp: 'MortimerCladwell 4/29/2018 10:05'!
initialize
	"comment stating purpose of message"
|| 
	wellsArray := Array new: numberOfWells.
	1 to: numberOfWells do: [ :i | wellsArray at: i put: PMSample new ]! !

!PMPlate methodsFor: 'initialization' stamp: 'mbc 4/14/2018 17:18'!
initializeNumberOfWells: someNumberOfWells
	"This is the accessor that will provide access to the class during initialization"
    numberOfWells := someNumberOfWells. 
  self initialize
	! !

GRObject subclass: #PMPlateSet
	instanceVariableNames: 'plateSetName numberOfPlates plateArray plateSetDescription date plateType uniqueID timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

PMPlateSet class
	instanceVariableNames: 'count'!

!PMPlateSet commentStamp: 'mbc 4/6/2018 17:16' prior: 0!
Will hold plates in plateArray!

PMPlateSet class
	instanceVariableNames: 'count'!

!PMPlateSet class methodsFor: 'accessing' stamp: 'mbc 4/30/2018 10:06'!
count
	"comment stating purpose of message"

	^ count! !

!PMPlateSet class methodsFor: 'as yet unclassified' stamp: 'mbc 5/6/2018 15:22'!
createInstance: aNumberOfPlates plateType: aPlateType plateSize: aPlateSize
	"comment stating purpose of message"

	count := count + 1.
	^ self basicNew
		initializeWithPlateNumber: aNumberOfPlates plateType: aPlateType plateSize: aPlateSize;
		yourself! !

!PMPlateSet class methodsFor: 'initialization' stamp: 'mbc 4/30/2018 10:45'!
initialize
	"comment stating purpose of message"

	count := 0! !

PMPlateSet initialize!

!PMPlateSet class methodsFor: 'instance creation' stamp: 'mbc 4/30/2018 10:46'!
new
	"comment stating purpose of message"

	^ super new! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/5/2018 05:21'!
date
	^ date! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/5/2018 05:21'!
date: anObject
	date := anObject! !

!PMPlateSet methodsFor: 'initialization' stamp: 'mbc 5/6/2018 15:21'!
initializeWithPlateNumber: aNumberOfPlates plateType: aPlateType plateSize: aPlateSize
	"comment stating purpose of message"

	self initialize.
	plateSetName := 'PS' , PMPlateSet count greaseString.
	timestamp := DateAndTime now.
	uniqueID := UUID new.
	plateArray := Array new: aNumberOfPlates.
	1 to: aNumberOfPlates do: [ :i | plateArray at: i put: (PMPlate initializePM: aPlateSize) ]! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/4/2018 14:45'!
numberOfPlates
	^ numberOfPlates! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/4/2018 14:45'!
numberOfPlates: anObject
	numberOfPlates := anObject! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/4/2018 14:45'!
plateArray
	^ plateArray! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/4/2018 14:45'!
plateArray: anObject
	plateArray := anObject! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/3/2018 14:55'!
plateSetDescription
	^ plateSetDescription! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/3/2018 14:55'!
plateSetDescription: anObject
	plateSetDescription := anObject! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/4/2018 14:45'!
plateSetName
	^ plateSetName! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/4/2018 14:45'!
plateSetName: anObject
	plateSetName := anObject! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/4/2018 14:45'!
plateType
	^ plateType! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/4/2018 14:45'!
plateType: anObject
	plateType := anObject! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/4/2018 14:45'!
timestamp
	^ timestamp! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/4/2018 14:45'!
timestamp: anObject
	timestamp := anObject! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/4/2018 14:45'!
uniqueID
	^ uniqueID! !

!PMPlateSet methodsFor: 'accessing' stamp: 'mbc 5/4/2018 14:45'!
uniqueID: anObject
	uniqueID := anObject! !

GRObject subclass: #PMPlateType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

PMPlateType class
	instanceVariableNames: 'types'!

!PMPlateType commentStamp: 'MortimerCladwell 4/29/2018 05:35' prior: 0!
A Platetype class is an abstract class meant to supply plate type descriptors only.
!

PMPlateType class
	instanceVariableNames: 'types'!

!PMPlateType class methodsFor: 'initialization' stamp: 'mbc 5/6/2018 13:50'!
initialize
	"comment stating purpose of message"
types := OrderedCollection withAll: #('96well' '384well' '1536well')
! !

PMPlateType initialize!

!PMPlateType class methodsFor: 'accessing' stamp: 'mbc 5/6/2018 13:47'!
types
	"comment stating purpose of message"
^ types ! !

GRObject subclass: #PMProject
	instanceVariableNames: 'uniqueID projectName projectDescription owner timestamp plateSets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

PMProject class
	instanceVariableNames: 'count'!

!PMProject commentStamp: 'mbc 5/5/2018 05:27' prior: 0!
I represent a Project.

I have an owner and a collection of plate sets.

To get started:
PMProject allInstances

PMProject initialize
PMPlateSet initialize
PMPlate initialize

PMProject createInstance: 'owner1'


PMPlateSet createInstance: 'PRJ10' numberOfPlates: 10 plateType: 'assay' plateSize: 96

!

PMProject class
	instanceVariableNames: 'count'!

!PMProject class methodsFor: 'accessing' stamp: 'MortimerCladwell 4/29/2018 09:55'!
count
	"comment stating purpose of message"

	|  |
	^ count! !

!PMProject class methodsFor: 'accessing' stamp: 'mbc 4/30/2018 09:46'!
createInstance: theOwner
	"comment stating purpose of message"
	
count := count + 1.
	^ self basicNew
		initializeWithOwner: theOwner;
		
		
		yourself! !

!PMProject class methodsFor: 'initialization' stamp: 'mbc 4/30/2018 09:30'!
initialize
	"comment stating purpose of message"
	count := 0! !

PMProject initialize!

!PMProject class methodsFor: 'instance creation' stamp: 'mbc 4/30/2018 09:44'!
new
	"comment stating purpose of message"
	^ super new! !

!PMProject methodsFor: 'adding' stamp: 'mbc 5/14/2018 11:46'!
addPlateSet: aPlateSet
	"comment stating purpose of message"

	plateSets at: aPlateSet plateSetName  put: aPlateSet! !

!PMProject methodsFor: 'adding' stamp: 'mbc 5/5/2018 10:09'!
addPlateSet: aNumberOfPlates plateType: aPlateType plateSize: aPlateSize
	"comment stating purpose of message"

	| aPlateSet |
	aPlateSet := PMPlateSet
		createInstance: self projectName
		numberOfPlates: aNumberOfPlates
		plateType: aPlateType
		plateSize: aPlateSize.
	plateSets at: aPlateSet plateSetName put: aPlateSet! !

!PMProject methodsFor: 'initialization' stamp: 'mbc 5/14/2018 11:43'!
initializeWithOwner: theOwner
	"comment stating purpose of message"

	owner := theOwner.
	projectName := 'PRJ' , PMProject count greaseString.
	timestamp := DateAndTime now.
	uniqueID := UUID new.
	plateSets := Dictionary new.
	self initialize! !

!PMProject methodsFor: 'accessing' stamp: 'MortimerCladwell 4/29/2018 14:53'!
owner
	^ owner! !

!PMProject methodsFor: 'accessing' stamp: 'MortimerCladwell 4/29/2018 14:53'!
owner: anObject
	owner := anObject! !

!PMProject methodsFor: 'accessing' stamp: 'mbc 5/11/2018 10:42'!
plateSets
	^ plateSets! !

!PMProject methodsFor: 'accessing' stamp: 'MortimerCladwell 4/29/2018 14:53'!
projectDescription
	^ projectDescription! !

!PMProject methodsFor: 'accessing' stamp: 'MortimerCladwell 4/29/2018 14:53'!
projectDescription: anObject
	projectDescription := anObject! !

!PMProject methodsFor: 'accessing' stamp: 'MortimerCladwell 4/29/2018 14:53'!
projectName
	^ projectName! !

!PMProject methodsFor: 'accessing' stamp: 'mbc 5/11/2018 10:42'!
projectName: anObject
	projectName := anObject! !

!PMProject methodsFor: 'accessing' stamp: 'MortimerCladwell 4/29/2018 14:53'!
timestamp
	^ timestamp! !

!PMProject methodsFor: 'accessing' stamp: 'mbc 5/11/2018 10:42'!
timestamp: anObject
	timestamp := anObject! !

!PMProject methodsFor: 'accessing' stamp: 'MortimerCladwell 4/29/2018 14:53'!
uniqueID
	^ uniqueID! !

!PMProject methodsFor: 'accessing' stamp: 'mbc 5/11/2018 10:42'!
uniqueID: anObject
	uniqueID := anObject! !

GRObject subclass: #PMSample
	instanceVariableNames: 'uniqueSampleID isHit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

!PMSample commentStamp: 'MortimerCladwell 3/25/2018 06:52' prior: 0!
A Sample is object of interest.

Instance Variables
	id:		<Object>

id
	- unique id
!

!PMSample methodsFor: 'initialization' stamp: 'MortimerCladwell 3/31/2018 06:29'!
initialize
	"comment stating purpose of message"

	|   |
	uniqueSampleID := UUID new.! !

GRObject subclass: #PMTask
	instanceVariableNames: 'completed deadline taskDescription id taskName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

!PMTask methodsFor: 'accessing' stamp: 'mbc 5/1/2018 15:04'!
completed
	^ completed! !

!PMTask methodsFor: 'accessing' stamp: 'mbc 5/1/2018 15:04'!
completed: anObject
	completed := anObject! !

!PMTask methodsFor: 'accessing' stamp: 'mbc 5/1/2018 15:04'!
deadline
	^ deadline! !

!PMTask methodsFor: 'accessing' stamp: 'mbc 5/1/2018 15:04'!
deadline: anObject
	deadline := anObject! !

!PMTask methodsFor: 'testing' stamp: 'mbc 5/1/2018 13:35'!
hasBeenMissed


 
^ self completed not and: [self deadline < Date today]! !

!PMTask methodsFor: 'accessing' stamp: 'mbc 5/1/2018 15:04'!
id
	^ id! !

!PMTask methodsFor: 'accessing' stamp: 'mbc 5/1/2018 15:04'!
id: anObject
	id := anObject! !

!PMTask methodsFor: 'initialization' stamp: 'mbc 5/1/2018 13:35'!
initialize


 
self

 

 
deadline: Date tomorrow;

 

 
completed: false.! !

!PMTask methodsFor: 'testing' stamp: 'mbc 5/1/2018 13:34'!
isPending


 
^ self completed not and: [self deadline >= Date today]! !

!PMTask methodsFor: 'accessing' stamp: 'mbc 5/1/2018 15:04'!
taskDescription
	^ taskDescription! !

!PMTask methodsFor: 'accessing' stamp: 'mbc 5/1/2018 15:04'!
taskDescription: anObject
	taskDescription := anObject! !

!PMTask methodsFor: 'accessing' stamp: 'mbc 5/1/2018 15:04'!
taskName
	^ taskName! !

!PMTask methodsFor: 'accessing' stamp: 'mbc 5/1/2018 15:04'!
taskName: anObject
	taskName := anObject! !

GRObject subclass: #PMUser
	instanceVariableNames: 'uniqueID userName email password tasks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

!PMUser commentStamp: 'mbc 4/30/2018 13:00' prior: 0!
I am a user.
I own projects.
I have a unique user ID
!

!PMUser methodsFor: 'adding' stamp: 'mbc 5/1/2018 13:33'!
addTask: aTask

 


 
^ self tasks add: aTask! !

!PMUser methodsFor: 'accessing' stamp: 'MortimerCladwell 4/23/2018 04:35'!
email
	^ email! !

!PMUser methodsFor: 'accessing' stamp: 'MortimerCladwell 4/23/2018 04:35'!
email: anObject
	email := anObject! !

!PMUser methodsFor: 'initialization' stamp: 'mbc 5/1/2018 13:33'!
initialize

 


 
self tasks: OrderedCollection new.! !

!PMUser methodsFor: 'accessing' stamp: 'MortimerCladwell 4/23/2018 04:35'!
password
	^ password! !

!PMUser methodsFor: 'accessing' stamp: 'MortimerCladwell 4/23/2018 04:35'!
password: anObject
	password := anObject! !

!PMUser methodsFor: 'accessing' stamp: 'mbc 4/30/2018 12:01'!
uniqueID
	^ uniqueID! !

!PMUser methodsFor: 'accessing' stamp: 'MortimerCladwell 4/23/2018 04:35'!
userName
	^ userName! !

WAComponent subclass: #PMListComponent
	instanceVariableNames: 'items filterBlock sortBlock renderItemBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

!PMListComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 14:50'!
filterBlock
	^ filterBlock! !

!PMListComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 14:50'!
filterBlock: anObject
	filterBlock := anObject! !

!PMListComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 14:50'!
items
	^ items! !

!PMListComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 14:50'!
items: anObject
	items := anObject! !

!PMListComponent methodsFor: 'rendering' stamp: 'mbc 5/1/2018 14:51'!
renderContentOn: html
	
html table: [(self sortBlock

 

 
value: (self filterBlock value: self items))

 

 
do: [:item | html tableRow: [self renderItemBlock

 

 

 

 

 

 

 
value: item

 

 

 

 

 

 

 
value: html]]].! !

!PMListComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 14:50'!
renderItemBlock
	^ renderItemBlock! !

!PMListComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 14:50'!
renderItemBlock: anObject
	renderItemBlock := anObject! !

!PMListComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 14:50'!
sortBlock
	^ sortBlock! !

!PMListComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 14:50'!
sortBlock: anObject
	sortBlock := anObject! !

WAComponent subclass: #PMMenuComponent
	instanceVariableNames: 'entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

!PMMenuComponent methodsFor: 'adding' stamp: 'mbc 5/1/2018 11:25'!
addEntry: aString withAction: aBlock

 


 
^ self entries add: aString -> aBlock! !

!PMMenuComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 11:31'!
entries
	^ entries! !

!PMMenuComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 11:31'!
entries: anObject
	entries := anObject! !

!PMMenuComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 11:33'!
initialize
  super initialize.
  entries := OrderedCollection new.! !

!PMMenuComponent methodsFor: 'rendering' stamp: 'mbc 5/1/2018 11:26'!
renderContentOn: html
	
self entries

 

 
do: [:entry |

 

 

 
html anchor

 

 

 

 
callback: entry value;

 

 

 

 
with: entry key]

 

 
separatedBy: [html space].! !

WAComponent subclass: #PMRootComponent
	instanceVariableNames: 'menuComponent listComponent taskEditor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

!PMRootComponent class methodsFor: 'testing' stamp: 'mbc 4/30/2018 14:16'!
canBeRoot
 
^true! !

!PMRootComponent methodsFor: 'hooks' stamp: 'mbc 4/30/2018 15:02'!
children

 


 
^ Array with: self menuComponent with: self listComponent! !

!PMRootComponent methodsFor: 'as yet unclassified' stamp: 'mbc 5/1/2018 14:17'!
editTask: aTask

 


 
self taskEditor task: aTask copy.

 
(self call: self taskEditor)

 

 
ifTrue: [aTask copyFrom: self taskEditor task].! !

!PMRootComponent methodsFor: 'initialization' stamp: 'mbc 5/1/2018 14:52'!
initialize
	super initialize.
	self
		initializeMenuComponent;
		initializeListComponent! !

!PMRootComponent methodsFor: 'initialization' stamp: 'mbc 5/1/2018 15:03'!
initializeListComponent
	self listComponent: PMListComponent new.
	self listComponent
		sortBlock: [ :items | items sort: [ :a :b | a deadline < b deadline ] ];
		renderItemBlock: [ :task :html | self renderTask: task asRowOn: html ].
	self showPendingTasks.
	self listComponent items: self testTasks ! !

!PMRootComponent methodsFor: 'initialization' stamp: 'mbc 5/1/2018 14:56'!
initializeMenuComponent
	
self menuComponent:(PMMenuComponent new

 

 
addEntry: 'All' withAction: [self showAllTasks];

 

 
addEntry: 'Completed' withAction: [self showCompletedTasks];

 

 
addEntry: 'Pending' withAction: [self showPendingTasks];

 

 
addEntry: 'Missed' withAction: [self showMissedTasks];

 

 
yourself).! !

!PMRootComponent methodsFor: 'accessing' stamp: 'mbc 4/30/2018 14:53'!
listComponent
	^ listComponent! !

!PMRootComponent methodsFor: 'accessing' stamp: 'mbc 4/30/2018 14:53'!
listComponent: anObject
	listComponent := anObject! !

!PMRootComponent methodsFor: 'accessing' stamp: 'mbc 4/30/2018 14:24'!
menuComponent
	^ menuComponent! !

!PMRootComponent methodsFor: 'accessing' stamp: 'mbc 4/30/2018 14:24'!
menuComponent: anObject
	menuComponent := anObject! !

!PMRootComponent methodsFor: 'rendering' stamp: 'mbc 5/1/2018 14:13'!
renderContentOn: html
	"I render everything by calling html"

	html heading: 'Plate Manager'.
	html div
		class: 'menu';
		with: self menuComponent.
	html div
		class: 'list';
		with: self listComponent
		
! !

!PMRootComponent methodsFor: 'rendering' stamp: 'mbc 5/1/2018 14:56'!
renderTask: aTask asRowOn: html


 
html tableData: [html

 

 
tableData: aTask deadline asString;

 

 
tableData: aTask taskName;

 

 
tableData: aTask taskDescription;

 

 
tableData: aTask completed asString].! !

!PMRootComponent methodsFor: 'as yet unclassified' stamp: 'mbc 5/1/2018 14:54'!
showAllTasks


 
self listComponent

 

 
filterBlock: [:items | items].! !

!PMRootComponent methodsFor: 'as yet unclassified' stamp: 'mbc 5/1/2018 14:55'!
showCompletedTasks


 
self listComponent

 

 
filterBlock: [:items | items select: [:item | item completed]].! !

!PMRootComponent methodsFor: 'as yet unclassified' stamp: 'mbc 5/1/2018 14:55'!
showMissedTasks

 


 
self listComponent

 

 
filterBlock: [:items | items select: [:item | item hasBeenMissed]].! !

!PMRootComponent methodsFor: 'as yet unclassified' stamp: 'mbc 5/1/2018 14:54'!
showPendingTasks


 
self listComponent

 

 
filterBlock: [:items | items select: [:item | item isPending]].! !

!PMRootComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 13:48'!
taskEditor
	^ taskEditor! !

!PMRootComponent methodsFor: 'accessing' stamp: 'mbc 5/1/2018 13:48'!
taskEditor: anObject
	taskEditor := anObject! !

!PMRootComponent methodsFor: 'tests' stamp: 'mbc 5/1/2018 14:58'!
testTasks


 
^ OrderedCollection

 

 
with: (PMTask new

 

 

 
deadline: Date yesterday;

 

 

 
completed: false;

 

 

 
taskName: 'Missed task')

 

 
with: (PMTask new

 

 

 
deadline: Date tomorrow;

 

 

 
completed: false;

 

 

 
taskName: 'Pending task')

 

 
with: (PMTask new

 

 

 
deadline: Date tomorrow;

 

 

 
completed: true;

 

 

 
taskName: 'Already completed task')! !

WAComponent subclass: #PMTaskEditor
	instanceVariableNames: 'task'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

!PMTaskEditor methodsFor: 'initialization' stamp: 'mbc 5/1/2018 13:40'!
initialize
	"comment stating purpose of message"

	super initialize.
	task := PMTask new! !

!PMTaskEditor methodsFor: 'rendering' stamp: 'mbc 5/1/2018 13:43'!
renderButtonsOn: html


 
html

 

 
tableData;

 

 
tableData: [

 

 

 
html submitButton

 

 

 

 
callback: [self answer: true];

 

 

 

 
value: 'Save'.

 

 

 
html submitButton

 

 

 

 
callback: [self answer: false];

 

 

 

 
value: 'Cancel'].! !

!PMTaskEditor methodsFor: 'rendering' stamp: 'mbc 5/1/2018 13:42'!
renderCompletedSelectionOn: html


 
html

 

 
tableData: [html text: 'Completed: '];

 

 
tableData: [

 

 

 
html select

 

 

 

 
add: true;

 

 

 

 
add: false;

 

 

 

 
on: #completed of: self task;

 

 

 

 
labels: [:value |

 

 

 

 

 
value

 

 

 

 

 

 
ifTrue: ['yes']

 

 

 

 

 

 
ifFalse: ['no']]].! !

!PMTaskEditor methodsFor: 'rendering' stamp: 'mbc 5/1/2018 13:40'!
renderContentOn: html


 
html div

 

 
class: 'generic lightbox';

 

 
with: [

 

 

 
html heading: 'Editing task'.

 

 

 
html form: [

 

 

 

 
html table: [

 

 

 

 

 
html

 

 

 

 

 

 
tableRow: [self renderNameInputOn: html];

 

 

 

 

 

 
tableRow: [self renderDescriptionInputOn: html];

 

 

 

 

 

 
tableRow: [self renderDateInputOn: html];

 

 

 

 

 

 
tableRow: [self renderCompletedSelectionOn: html];

 

 

 

 

 

 
tableRow: [self renderButtonsOn: html]]]].! !

!PMTaskEditor methodsFor: 'rendering' stamp: 'mbc 5/1/2018 13:42'!
renderDateInputOn: html


 
html

 

 
tableData: [html text: 'Deadline: '];

 

 
tableData: [html dateInput on: #deadline of: self task].! !

!PMTaskEditor methodsFor: 'rendering' stamp: 'mbc 5/1/2018 13:42'!
renderDescriptionInputOn: html


 
html

 

 
tableData: [html text: 'Description: '];

 

 
tableData: [html textArea on: #taskDescription of: self task].! !

!PMTaskEditor methodsFor: 'rendering' stamp: 'mbc 5/1/2018 13:41'!
renderNameInputOn: html


 
html

 

 
tableData: [html text: 'Name: '];

 

 
tableData: [html textInput on: #taskName of: self task].! !

!PMTaskEditor methodsFor: 'accessing' stamp: 'mbc 5/1/2018 13:38'!
task
	^ task! !

!PMTaskEditor methodsFor: 'accessing' stamp: 'mbc 5/1/2018 13:38'!
task: anObject
	task := anObject! !

TestCase subclass: #PMProjectTest
	instanceVariableNames: 'aProject aPlateSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PlateManager'!

!PMProjectTest methodsFor: 'initialization' stamp: 'mbc 5/14/2018 11:10'!
setUp
	"comment stating purpose of message"

	aProject := PMProject createInstance: 'owner1'.
	aPlateSet := PMPlateSet createInstance: 10 plateType: 'assay' plateSize: 96.
	aProject addPlateSet: aPlateSet
			! !

!PMProjectTest methodsFor: 'tests' stamp: 'mbc 5/14/2018 11:47'!
testProjectArray
	"comment stating purpose of message"

	self assert: aProject owner equals: 'owner1'.
	self assert: aProject plateSets size = 1! !

PMAssayRun initialize!

PMProject initialize!

PMPlateType initialize!

PMPlateSet initialize!
